from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.MemberImport.MemberImportTool import \
    MemberImportTool
from Products.MemberImport.config import PROJECTNAME, GLOBALS

from StringIO import StringIO

def install(self):
    out = StringIO()

    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)

    install_subskin(self, out, GLOBALS)

    install_tools(self, out)
    
    # add portlet
    portlet_path = 'here/portlet_member_import/macros/portlet'
    if portlet_path not in self.right_slots:
        right_slots = tuple(self.right_slots) + (
                'here/portlet_member_import/macros/portlet',
        )
        self._updateProperty('right_slots', right_slots)

    out.write("Successfully installed %s." % PROJECTNAME)
    return out.getvalue()


def install_tools(portal, out):
    # install member import tool
    if not hasattr(portal, 'member_import_tool'):
        portal.manage_addProduct[PROJECTNAME].manage_addTool(
            MemberImportTool.meta_type, None)
        print >> out, "Successfully installed Member Import Tool."
